<?php

namespace Drupal\hidden_nodes\Form;

use Drupal\book\Form\BookAdminEditForm;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;
use Drupal\node\NodeInterface;

class HiddenNodesBookAdminForm extends BookAdminEditForm {
  public function buildForm(array $form, FormStateInterface $form_state, NodeInterface $node = NULL) {
    return parent::buildForm($form, $form_state, $node);
  }

  public function bookAdminTableTree(array $tree, array &$form) {
    parent::bookAdminTableTree($tree, $form);

    foreach ($tree as $data) {
      $nid = $data['link']['nid'];
      $id = 'book-admin-' . $nid;

      $destination = $this->getDestinationArray();
      $access = \Drupal::currentUser()->hasPermission('administer nodes');

      if ($access) {
        $form[$id]['operations']['#links']['toggle_hidden'] = [
          'title' => $this->t('Hide Node'),
          'url' => new Url('hidden_nodes.modal_form', ['book' => 2, 'node' => $nid]),
          'query' => $destination,
          'weight' => 50,
          'attributes' => [
            'class' => ['use-ajax']
          ]
        ];
      }
    }
    $form['#attached']['library'][] = 'core/drupal.dialog.ajax';
  }

}
